﻿using SqlSugar;
using System.ComponentModel;
using XF.Domain.Repository;

namespace Hotline.DataSharing.Province.Other
{
    /// <summary>
    /// 省12345待推送数据
    /// </summary>
    [Description("省12345待推送数据")]
    public class DsWaitingPushData : CreationEntity
    {
        /// <summary>
        /// 服务接口名称
        /// </summary>
        [SugarColumn(ColumnDescription = "服务接口名称", ColumnDataType = "varchar(30)")]
        public string ServiceInterface { get; set; }

        /// <summary>
        /// 推送数据
        /// </summary>
        [SugarColumn(ColumnDescription = "推送数据", ColumnDataType = "text")]
        public string Data { get; set; }

        /// <summary>
        /// 待同步数据ID
        /// </summary>
        [SugarColumn(ColumnDescription = "待同步数据ID", ColumnDataType = "varchar(50)")]
        public string SyncID { get; set; }

        /// <summary>
        /// 推送优先级
        /// </summary>
        [SugarColumn(ColumnDescription = "推送优先级")]
        public int Priority { get; set; } = 0;

        /// <summary>
        /// 推送地址
        /// </summary>
        [SugarColumn(ColumnDescription = "推送地址", ColumnDataType = "varchar(100)", IsNullable = true)]
        public string PushUrl { get; set; }

        /// <summary>
        /// 推送方式 post、get
        /// </summary>
        [SugarColumn(ColumnDescription = "推送方式 post、get", ColumnDataType = "varchar(10)", IsNullable = true)]
        public string Method { get; set; }

        /// <summary>
        /// 重新推送次数
        /// </summary>
        [SugarColumn(ColumnDescription = "重新推送次数")]
        public int SyncCount { get; set; } = 0;

        /// <summary>
        /// 第一次工单同步省平台时间
        /// </summary>
        [SugarColumn(ColumnDescription = "第一次工单同步省平台时间", IsNullable = true)]
        public DateTime? FirstSyncProvinceTime { get; set; }

        /// <summary>
        /// 最新工单同步省平台时间
        /// </summary>
        [SugarColumn(ColumnDescription = "最新工单同步省平台时间", IsNullable = true)]
        public DateTime? NewSyncProvinceTime { get; set; }

        /// <summary>
        /// 同步成功时间
        /// </summary>
        [SugarColumn(ColumnDescription = "同步成功时间", IsNullable = true)]
        public DateTime? SuccessSyncTime { get; set; }

        /// <summary>
        /// 接口返回结果
        /// </summary>
        [SugarColumn(ColumnDataType = "json", IsJson = true, IsNullable = true)]
        public string? ReturnResult { get; set; }

        /// <summary>
        /// 同步状态 0：待同步；	  1：同步成功；	 2：同步失败；
        /// </summary>
        [SugarColumn(ColumnDescription = "同步状态", ColumnDataType = "varchar(1)", IsNullable = true)]
        public string SyncState { get; set; } = "0";
    }
}
